//+------------------------------------------------------------------+
//|                                                   T3MA_ALARM.mq4 |
//|                                     Copyright  2011, Martingeil |
//|                                                    fx.09@mail.ru | 
//+------------------------------------------------------------------+
// Martingeil,       .
#property copyright "Copyright  2011, Martingeil"
#property link      "fx.09@mail.ru"

//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 2
#property  indicator_color1  Lime
#property  indicator_color2  Red
//---- indicator parameters
extern int  period = 12; //12
extern int  shift  = 0; //  
extern int ArrOtstup = 2;
extern bool AlertsMessage  = true; 
extern bool AlertsSound    = true;
extern bool AlertsEmail    = false;
extern bool AlertsMobile   = false;

datetime TimeBar;

//---- indicator buffers
double BufferUp[],BufferDn[];
int q,st;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(2);
//---- drawing settings
   SetIndexStyle(0,DRAW_ARROW,2);
   SetIndexArrow(0,217);
   SetIndexStyle(1,DRAW_ARROW,2);
   SetIndexArrow(1,218);   
   
   SetIndexBuffer(0,BufferUp);//  
   SetIndexBuffer(1,BufferDn);//  
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("T3MA-ALARM ("+period+")");
//---- initialization done
if(Digits==3 || Digits==5) q=10; else q=1; 
st=ArrOtstup*q;
return(0);}

int deinit()
{
Comment("");
ObjectDelete("low");
ObjectDelete("high");  
return(0);
}  
//+----------------------------------------------------------------------+
//| Moving Average of Oscillator                                         |
//+----------------------------------------------------------------------+
int start()
  {
//---- ArraySetAsSeries --------------------------------------------------  
double Ma[1000],MaOn[1000];
double y0[1000],y1[1000],y2[1000];
int    i,limit=ArraySize(Ma); 
ArraySetAsSeries(Ma,true);
//---- IndicatorCounted --------------------------------------------------
int    counted_bars=IndicatorCounted();
int    limit1=Bars-counted_bars;
       if (limit1>1){limit1=Bars-period-1;} 
//---- EMA --------------------------------------------------------------- 
for(i=limit1; i>=0; i--)  Ma[i]  =iMA(NULL,0,period,0,MODE_EMA,PRICE_CLOSE,i);
for(i=limit1; i>=0; i--)  MaOn[i]=iMAOnArray(Ma,limit,period,0,MODE_EMA,i); 
   
for(i=limit1; i>=0; i--)
   {   
       y0[i+shift]=MaOn[i+shift];
       y1[i+1+shift]=MaOn[i+1+shift];
       y2[i+2+shift]=MaOn[i+2+shift];
       
       if(y0[i+shift]-y1[i+1+shift]<0 && y1[i+1+shift]-y2[i+2+shift]>0){BufferDn[i+1]=High[i+1]+st*Point;}
       if(y0[i+shift]-y1[i+1+shift]>0 && y1[i+1+shift]-y2[i+2+shift]<0){BufferUp[i+1]=Low[i+1]-st*Point;} 
       }           

//-------------------------------------------------------------------+   
 if(AlertsMessage || AlertsSound || AlertsEmail || AlertsMobile)
  { 
   string message1 = (WindowExpertName()+" - "+Symbol()+"  "+PeriodString()+" - Buy");
   string message2 = (WindowExpertName()+" - "+Symbol()+"  "+PeriodString()+" - Sell");
       
    if(TimeBar!=Time[0] && BufferUp[1] != EMPTY_VALUE && BufferUp[1] != 0)
     { 
        if (AlertsMessage) Alert(message1);
        if (AlertsSound)   PlaySound("alert.wav");
        if (AlertsEmail)   SendMail(Symbol()+" - "+WindowExpertName()+" - ",message1);
        if (AlertsMobile)  SendNotification(message1);
        TimeBar=Time[0];
     }
    if(TimeBar!=Time[0] && BufferDn[1] != EMPTY_VALUE && BufferDn[1] != 0)
     { 
        if (AlertsMessage) Alert(message2);
        if (AlertsSound)   PlaySound("alert.wav");
        if (AlertsEmail)   SendMail(Symbol()+" - "+WindowExpertName()+" - ",message2);
        if (AlertsMobile)  SendNotification(message2);
        TimeBar=Time[0];
    }
  }
//-------------------------------------------------------------------+
   return(0);
  }
//-------------------------------------------------------------------+ 
string PeriodString()
{
    switch (_Period) 
     {
        case PERIOD_M1:  return("M1");
        case PERIOD_M5:  return("M5");
        case PERIOD_M15: return("M15");
        case PERIOD_M30: return("M30");
        case PERIOD_H1:  return("H1");
        case PERIOD_H4:  return("H4");
        case PERIOD_D1:  return("D1");
        case PERIOD_W1:  return("W1");
        case PERIOD_MN1: return("MN1");
     }    
   return("M" + string(_Period));
}
//-------------------------------------------------------------------+



